<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="{basePath}/svg-inject.min.js"></script>
    <script src="{basePath}/jquery-3.5.1.min.js"></script>
    <link rel="stylesheet" href="{basePath}/common.css">
    <link rel="stylesheet" href="{basePath}/memoryViewDark.css">
    <link rel="stylesheet" href="{basePath}/bootstrap-4.5.2-dist/css/bootstrap.css">
</head>

<body>
    <div class="loadingContainer">
        <img src="{basePath}/../../resources/dark/loading.svg" style="stroke: white;" onload="SVGInject(this)" />
    </div>
    <div class="container-fluid">
        <div class="row" style="margin-top: 5px; margin-bottom: 5px;">
            <div class="col">
                <input class="form-control" id="input" style="width: 150px; float: left; margin-right: 5px;" value="00000000" />
                <button type="button" class="btn btn-primary" onclick='inputMemory()'>Go</button> 
                <input type="radio" id="bin" name="Positionalnotation" onchange="Changepn()">
                <label>bin</label>
                <input type="radio" id="oct" name="Positionalnotation" onchange="Changepn()">
                <label>oct</label>
                <input type="radio" id="dec" name="Positionalnotation" onchange="Changepn()">
                <label>dec</label>
                <input type="radio" id="hex" name="Positionalnotation" onchange="Changepn()" checked>
                <label>hex</label>
            </div>
            <div class="col">
                <button type="button" class="btn btn-primary" onclick="next()">Search</button> 
            </div> 
        </div>
            <div class="row">
                <div class="col">
                    <table class="table" id="cartGrid">
                        <thead>
                            <tr>
                                <th scope="col">Address</th>
                                <th scope="col">0</th>
                                <th scope="col">1</th>
                                <th scope="col">2</th>
                                <th scope="col">3</th>
                                <th scope="col">4</th>
                                <th scope="col">5</th>
                                <th scope="col">6</th>
                                <th scope="col">7</th>
                                <th scope="col">8</th>
                                <th scope="col">9</th>
                                <th scope="col">A</th>
                                <th scope="col">B</th>
                                <th scope="col">C</th>
                                <th scope="col">D</th>
                                <th scope="col">E</th>
                                <th scope="col">F</th>
                                <th scope="col">string</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>    
    <script>
        const vscode = acquireVsCodeApi();
        parser = new DOMParser();
        var changed_address = [];
        window.addEventListener('message', event => {
            const message = event.data;
            switch (message.type) {
                case 'stopLoading':
                    $('.loadingContainer').css('display', 'none');
                    break;
                case 'initalAddressArray':
                    while(globalThis.changed_address.length){
                        globalThis.changed_address.pop();
                    }
                    break;
                case 'initial':
                    Changepn();
                    break;
                case 'ddd':
                    changed_address = message.array;
                    getMemory(message.text);
                 break;
                case 'update':
                    $('.table tbody').html($('.table tbody').html(""));                     
                    xmlDoc = parser.parseFromString(message.xml, "text/xml");               
                    let MemoryNode = xmlDoc.getElementsByTagName("memory")[0];           
                    var base=2;
                    
                    for (let x = 0; x < MemoryNode.childNodes.length; x++) {
                        let node = MemoryNode.childNodes[x];
                        if (node.nodeType == Node.ELEMENT_NODE) {
                            base = parseInt(node.getAttribute('base'));
                            
                            var address = node.getAttribute('value'); 
                            var val = node.firstChild.nodeValue.replace(/\s+/g,' ').trim().split(" ");
                            var str = "";
                            var str1 = "";
                            
                            for (let y = 0; y < 16; y++) {                    
                                str = str+ `<td id="${y}">` + val[y].toString().padStart(2, '0') + '</td>';
                                str1 += String.fromCharCode(parseInt(val[y],base));                                                 
                            }

                            $('.table tbody').html($('.table tbody').html() + `<tr>
                                <td>` + address.toString(16).padStart(8, '0') + `</td>`
                                + str + '<td>' + str1 + '</td>' + '</tr>');

                        }
                    }
                    
                    if(changed_address.length>0){
                        LightModifiedAddress();
                    }
                                         
                    break;
                case 'lightTheUpdated':
                    xmlDoc = parser.parseFromString(message.xml, "text/xml");      
                    let memNode = xmlDoc.getElementsByTagName("updateMemoryAddress")[0];  
               
                    for (let x = 0; x < memNode.childNodes.length; x++) {
                        let node = memNode.childNodes[x];

                        if (node.nodeType == Node.ELEMENT_NODE) {
                            var address = parseInt(node.firstChild.nodeValue,16);
                            globalThis.changed_address.push(address);     
                        }
                    }
                   
                    LightModifiedAddress();
                    break; 

            }
        }); 

        function inputMemory(){
            var x =parseInt(parseInt(document.getElementById("input").value,16) /16);
            x = x*16;
            x = x.toString(16);
            getMemory(x);
        }

        function getMemory(x) {
            vscode.postMessage({
                command: 'getMemory',
                text: x
            });
        }

        function next(){
            var t = document.getElementById("cartGrid");
            var row1 = t.getElementsByTagName("tr")[1];
            var val_firstRowFirstCol = parseInt(row1.getElementsByTagName("td")[0].innerText,16).toString(16);

            vscode.postMessage({
                command: 'next',
                text: val_firstRowFirstCol,
                array: changed_address
            });        }

        function LightModifiedAddress(){
            var t = document.getElementById("cartGrid");
            var row1 = t.getElementsByTagName("tr")[1];
            var val_firstRowFirstCol = parseInt(row1.getElementsByTagName("td")[0].innerText,16);
            var lastrow = t.getElementsByTagName("tr")[t.getElementsByTagName("tr").length-1];
            var val_LastrowLastcol = parseInt(lastrow.getElementsByTagName("td")[0].innerText,16);
            var address = changed_address[0];
            if(address >= val_firstRowFirstCol && address <= val_LastrowLastcol){   
                for(let x=0 ; x< changed_address.length;x++){
                    address = changed_address[x];
                    var quo = parseInt(address/16);
                    var location = quo*16;
                    var remainder = address% 16;

                    for(let i=1 ;i<t.getElementsByTagName("tr").length ;i++){
                        var row = t.getElementsByTagName("tr")[i];
                        var col1_val = parseInt(row.getElementsByTagName("td")[0].innerText,16);
                        if(col1_val == location){
                            $(`#${(i-1)*8+remainder}`).addClass('highlight');
                                break;
                        }   
                    }
                }
            }  
        }

        function Changepn(){
            var base;
            if(document.getElementById('bin').checked){
                base = 't'
            }else if(document.getElementById('oct').checked){
                base = 'o'
            }else if(document.getElementById('hex').checked){
                base = 'x'
            }else if(document.getElementById('dec').checked){
                base = 'd'
            }

            vscode.postMessage({
                command: 'changeBase',
                text: base
            });  

    }
        
    </script> 
</body>

</html>